Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Diffuse.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Diffuse.material	(revision 1525)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Diffuse.material	(revision 1590)
@@ -72,5 +72,4 @@
 		fragment_program_ref GameTools/DiffusePS
 		{ 
-			param_named_auto cameraPos camera_position
 			param_named REDUCED_CUBEMAP_SIZE int 8
 			param_named lastCenter float3 0 0 0		
@@ -112,4 +111,6 @@
 } 
 
+
+
 material GameTools/Diffuse/use
 { 
@@ -146,8 +147,5 @@
 		fragment_program_ref Diffuse2PS
 		{ 
-			param_named_auto cameraPos camera_position
-			param_named REDUCED_CUBEMAP_SIZE int 4
 			param_named lastCenter float3 0 0 0
-			 param_named_auto world_IT inverse_transpose_world_matrix		
 		} 
 		
@@ -170,2 +168,69 @@
    }
 }
+
+
+fragment_program DiffuseP2PPS hlsl
+{
+	source GameTools_Diffuse.hlsl
+	entry_point EnvMapDiffuseP2PPS
+	target ps_3_0
+} 
+
+material GameTools/Diffuse/use1
+{ 
+   technique 
+   { 
+      pass 
+      { 
+		
+		IllumTechniques
+		{
+			RenderTechnique DistanceCubeMap
+			{
+				update_interval		1
+				distance_calc false	
+				face_angle_calc false
+				update_all_face		true					
+			}
+			RenderTechnique ReducedColorCubeMap
+			{
+				update_interval		1
+				reduced_resolution 4
+				resolution 128
+				distance_calc false
+				face_angle_calc false
+				update_all_face		true
+			}
+		}
+      
+
+		vertex_program_ref Diffuse2VS
+		{       
+		 param_named_auto worldViewProj worldviewproj_matrix 
+    		param_named_auto world world_matrix  
+        
+		} 
+		fragment_program_ref DiffuseP2PPS
+		{ 
+			param_named REDUCED_CUBEMAP_SIZE int 4
+			param_named lastCenter float3 0 0 0				
+		} 
+		
+		//Cube map for reflections and refractions	
+		texture_unit
+		{
+			cubic_texture cubemap.jpg combinedUVW
+			tex_address_mode clamp
+			colour_op replace
+		}
+
+		//Cube map of distances
+		texture_unit
+		 {
+		   cubic_texture cubemap.jpg combinedUVW
+		   tex_address_mode clamp
+		   colour_op replace
+		 }
+	 }
+   }
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/diffscene.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/diffscene.material	(revision 1590)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/diffscene.material	(revision 1590)
@@ -0,0 +1,218 @@
+vertex_program PhongVS hlsl
+{
+	source GameTools_Phong.hlsl
+	entry_point PhongVS
+	target vs_2_0
+} 
+
+fragment_program PhongPS hlsl
+{
+	source GameTools_Phong.hlsl
+	entry_point PhongPS
+	target ps_3_0
+} 
+
+material GameTools/Phong
+{ 
+
+   technique 0
+   { 
+      
+      pass 0
+      { 		
+		vertex_program_ref PhongVS
+       	{       
+       	   param_named_auto worldViewProj worldviewproj_matrix
+           param_named_auto world world_matrix
+    	} 
+		fragment_program_ref  PhongPS
+		{ 
+		   param_named_auto cameraPos camera_position 
+		
+		   param_named_auto lightcol1 light_diffuse_colour 0	
+		   param_named_auto lightcol2 light_diffuse_colour 1
+		   param_named_auto lightcol3 light_diffuse_colour 2
+		   param_named_auto lightcol4 light_diffuse_colour 3
+		   param_named_auto lightcol5 light_diffuse_colour 4
+		   param_named_auto lightcol6 light_diffuse_colour 5
+		   param_named_auto lightcol7 light_diffuse_colour 6
+		   param_named_auto lightcol8 light_diffuse_colour 7
+		   
+		   param_named_auto lightpos1 light_position 0
+		   param_named_auto lightpos2 light_position 1
+		   param_named_auto lightpos3 light_position 2
+		   param_named_auto lightpos4 light_position 3
+		   param_named_auto lightpos5 light_position 4
+		   param_named_auto lightpos6 light_position 5
+		   param_named_auto lightpos7 light_position 6
+		   param_named_auto lightpos8 light_position 7
+		   
+		   param_named_auto ambientLight ambient_light_colour 
+		   
+		   param_named shininess float 20
+		   param_named ambient float4 0.2 0.2 0.2 1
+		   param_named diffuse float4 0.5 0.5 0.5 1
+		   param_named specular float4 1 1 1 1
+		 }	        
+        
+       }
+    }
+}
+
+
+
+material asztallap : GameTools/Phong
+{
+	technique 0
+	{
+		pass 0
+		{
+			fragment_program_ref
+			{
+				param_named shininess float 7.028
+				param_named ambient 0.560857 0.761 0.733514 1
+				param_named diffuse 0.560857 0.761 0.733514 1 				
+			}			
+		}
+	}	
+}
+material pult : GameTools/Phong
+{
+	technique 0
+	{
+		pass 0
+		{
+			fragment_program_ref
+			{
+				param_named shininess float 2
+				param_named ambient 0.819489 0.891 0.656667 1
+				param_named diffuse 0.819489 0.891 0.656667 1
+				param_named specular 0.53846 0.53846 0.53846 1	
+			}			
+		}
+	}	
+}
+
+material fal : GameTools/Phong
+{
+	technique 0
+   { 
+      
+      pass 0
+      { 		
+		fragment_program_ref
+		{
+		   param_named shininess float 0
+		   param_named ambient float4 0.68229 0.855 0.737241 1
+		   param_named diffuse float4 0.68229 0.855 0.737241 1		
+		}        
+       }
+    }
+}
+
+material butorlap : GameTools/Phong
+{
+	technique 0
+	{
+		pass 0
+		{
+			fragment_program_ref
+			{
+				param_named shininess float 32.154
+				param_named ambient 0.177898 0.917 0.472184 1
+				param_named diffuse 0.177898 0.917 0.472184 1				
+			}			
+		}
+	}
+}
+
+material lampa3
+{
+	technique
+	{
+		pass
+		{
+			ambient 0 0 0 1
+			diffuse 0 0 0 1
+			specular 0 0 0 0
+			emissive 2.0 2.0 2.0
+		}
+	}
+}
+material tetolampakek
+{
+	technique
+	{
+		pass
+		{
+			cull_hardware none
+			lighting off
+			texture_unit
+			{
+				texture tetolampakek.jpg
+				colour_op replace
+			}
+
+		}
+	}
+}
+material tetolampasarga
+{
+	technique
+	{
+		pass
+		{
+			cull_hardware none
+
+			lighting off
+			texture_unit
+			{
+				texture tetolampasarga.jpg
+				colour_op replace
+			}
+
+		}
+	}
+}
+material talaj
+{
+technique
+{
+		pass
+		{
+			ambient 1 1 1 1
+			diffuse 1 1 1 1
+			specular 1 1 1 2
+			emissive 0 0 0
+						
+	//		shading phong
+
+			texture_unit
+			{
+				texture talaj.jpg
+				tex_coord_set 0
+				colour_op modulate
+				
+
+			}
+		}
+	}
+}
+material paravan
+{
+	technique
+	{
+		pass
+		{
+			cull_hardware none
+
+			ambient 1 0.408055 0.07 0.79488
+			diffuse 1 0.408055 0.07 0.79488
+			specular 0 0 0 0
+			emissive 0.3 0.15 0.03
+
+			scene_blend alpha_blend
+			depth_write off
+		}
+	}
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Glow.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Glow.material	(revision 1441)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/Glow.material	(revision 1590)
@@ -50,6 +50,7 @@
 		param_named_auto width viewport_width 	
 	        param_named_auto height viewport_height
+		//param_named cutValue float 10.0
 		param_named cutValue float 10.0
-		param_named timeBlur float 0.01
+		param_named timeBlur float 0.4
 	        
          }
@@ -106,5 +107,5 @@
 			param_named_auto width viewport_width 	
 	        param_named_auto height viewport_height 
-	        param_named Stretch float 1.5
+	        param_named Stretch float 1.2
          }
         texture_unit
@@ -131,5 +132,5 @@
 			param_named_auto width viewport_width 	
 	        param_named_auto height viewport_height 
-	        param_named Stretch float 1.5
+	        param_named Stretch float 1.2
          }
         texture_unit
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Phong.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Phong.hlsl	(revision 1590)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Phong.hlsl	(revision 1590)
@@ -0,0 +1,103 @@
+
+
+struct vertOUT
+{
+	float4 hPos :POSITION;
+	float3 wPos	:TEXCOORD1;
+	float2 texCoord :TEXCOORD0;
+	float3 mNormal :TEXCOORD2;
+};
+
+vertOUT PhongVS(float4 position : POSITION,
+		float3 normal   : NORMAL,
+		half3 tangent   : TEXCOORD1, 
+		float2 texCoord : TEXCOORD0,			
+		uniform float4x4 worldViewProj,
+		uniform float4x4 world)
+{
+  vertOUT OUT;
+  OUT.hPos = mul(worldViewProj, position);
+  OUT.wPos = mul(world, position).xyz;  
+  OUT.mNormal = mul(world, normal);
+  //OUT.mNormal = normal;
+  OUT.texCoord = texCoord;
+  return OUT;
+}
+
+
+
+float4 PhongPS( vertOUT IN,
+           uniform float3 cameraPos,
+	   uniform float3 lightpos1,
+	   uniform float3 lightpos2,
+	   uniform float3 lightpos3,
+	   uniform float3 lightpos4,
+	   uniform float3 lightpos5,
+	   uniform float3 lightpos6,
+	   uniform float3 lightpos7,
+	   uniform float3 lightpos8,
+	   uniform float4 lightcol1,
+	   uniform float4 lightcol2,
+	   uniform float4 lightcol3,
+	   uniform float4 lightcol4,
+	   uniform float4 lightcol5,
+	   uniform float4 lightcol6,
+	   uniform float4 lightcol7,
+	   uniform float4 lightcol8,
+	   uniform float4 ambientLight,
+	   uniform float shininess,
+	   uniform float4 specular,
+	   uniform float4 diffuse,
+	   uniform float4 ambient           
+
+            ) : COLOR0
+{
+   
+	
+    float3 N = IN.mNormal;
+    N = normalize( N ); 
+    float3 pos = IN.wPos;
+    
+    float M = 8;
+   
+    float3 lightpositions[8];
+    float4 lightcolors[8];
+
+    lightpositions[0] = lightpos1;
+    lightpositions[1] = lightpos2;
+    lightpositions[2] = lightpos3;
+    lightpositions[3] = lightpos4;
+    lightpositions[4] = lightpos5;
+    lightpositions[5] = lightpos6;
+    lightpositions[6] = lightpos7;
+    lightpositions[7] = lightpos8;
+
+    lightcolors[0] = lightcol1;
+    lightcolors[1] = lightcol2;
+    lightcolors[2] = lightcol3;
+    lightcolors[3] = lightcol4;
+    lightcolors[4] = lightcol5;
+    lightcolors[5] = lightcol6;
+    lightcolors[6] = lightcol7;
+    lightcolors[7] = lightcol8;
+
+    float4 I = ambientLight * ambient;
+	
+    for(int i=0; i< M; i++)
+    {
+	float3 V = normalize(cameraPos - pos);
+	float3 L = lightpositions[i] - pos;
+	float d = length(L);
+	L = normalize(L);
+	float3 H = normalize(L + V);
+	float4 spec = specular * lightcolors[i] * pow(dot(H, N), shininess);
+	float4 diff = diffuse * lightcolors[i] * abs(dot(L, N));
+	float range = 4.0;
+	I += 1.0 / d * (spec + diff);	
+    }
+
+//return 1;
+    return I;
+
+}
+
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Diffuse.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Diffuse.hlsl	(revision 1565)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Diffuse.hlsl	(revision 1590)
@@ -11,5 +11,5 @@
 {
 	float dist = texCUBE(dcm, float3(coord.xy, - coord.z)).r;
-	if(dist == 0) dist = 100000; ///sky
+	if(dist == 0) dist = 1000000; ///sky
 	return dist;
 }
@@ -48,18 +48,17 @@
 ///////////////////
 
-float4 GetContibution(float3 L1, float3 L2, float3 L3, float3 L4, float3 pos, float3 N, samplerCUBE SmallEnvMapSampler, float d)
-{
-/*
-	L1 = readDistanceCubeMap(DistanceEnvMapSampler, L1) * normalize(L1);
-	L2 = readDistanceCubeMap(DistanceEnvMapSampler, L2) * normalize(L2);
-	L3 = readDistanceCubeMap(DistanceEnvMapSampler, L3) *  normalize(L3);
-	L4 = readDistanceCubeMap(DistanceEnvMapSampler, L4) * normalize(L4);
-*/	
-
+float4 GetContibution(float3 L, float3 L1, float3 L2, float3 L3, float3 L4, float3 pos, float3 N, samplerCUBE cubemap)
+{
+	float d;
+	//d = texCUBE(cubemap, L).a;	
+	d = readDistanceCubeMap(cubemap, L1).r;	
 	L1 = d * normalize(L1);
+	d = readDistanceCubeMap(cubemap, L2).r;	
 	L2 = d * normalize(L2);
-	L3 = d *  normalize(L3);
+	d = readDistanceCubeMap(cubemap, L3).r;	
+	L3 = d * normalize(L3);
+	d = readDistanceCubeMap(cubemap, L4).r;	
 	L4 = d * normalize(L4);
-	
+		
 	
     float3 r1 = normalize(L1 - pos);    
@@ -67,15 +66,35 @@
     float3 r3 = normalize(L3 - pos);
     float3 r4 = normalize(L4 - pos);
-   
-    
-	float kd = 0.3;	// 0.3
-	
+  /*     	
 	float tri1 = acos(dot(r1, r2)) * dot(cross(r1, r2), N);
 	float tri2 = acos(dot(r2, r3)) * dot(cross(r2, r3), N);
 	float tri3 = acos(dot(r3, r4)) * dot(cross(r3, r4), N);
 	float tri4 = acos(dot(r4, r1)) * dot(cross(r4, r1), N);
-	
+  */
+  float3 crossP = cross(r1, r2);
+  float r = length(crossP);
+  float dd = dot(r1,r2);
+  float tri1 = acos(dd) * dot(crossP/r, N);
+  
+  crossP = cross(r2, r3);
+  r = length(crossP);
+  dd = dot(r1,r2);
+  float tri2 = acos(dd) * dot(crossP/r, N);
+  
+  crossP = cross(r3, r4);
+  r = length(crossP);
+  dd = dot(r1,r2);
+  float tri3 = acos(dd) * dot(crossP/r, N);
+  
+  crossP = cross(r4, r1);
+  r = length(crossP);
+  dd = dot(r1,r2);
+  float tri4= acos(dd) * dot(crossP/r, N);
+  
+  
 	return max(tri1 + tri2 + tri3 + tri4, 0);	
-}
+	//return tri1 + tri2 + tri3 + tri4;	
+}
+
 
 struct vertOUT
@@ -97,48 +116,44 @@
   OUT.hPos = mul(worldViewProj, position);
   OUT.wPos = mul(world, position).xyz;  
-  //mNormal = mul(normal, world_IT);
-  OUT.mNormal = normal;
+  OUT.mNormal = mul(world, normal);
+  //OUT.mNormal = normal;
   OUT.texCoord = texCoord;
   return OUT;
 }
 
-/*
+
 float4 DiffusePS( vertOUT IN,
            uniform float3 cameraPos,
            uniform float3 lastCenter,	//LI//
            uniform samplerCUBE SmallEnvMapSampler : register(s0),
-           uniform samplerCUBE DistanceEnvMapSampler : register(s1),
-           uniform float4x4 world_IT
+           uniform samplerCUBE DistanceEnvMapSampler : register(s1)
             ) : COLOR0
 {
-    REDUCED_CUBEMAP_SIZE = 4;
-	float width = 1.0 /REDUCED_CUBEMAP_SIZE;
-   
-    normalize( V );
-    float3 V = normalize(IN.wPos - cameraPos);	// 
-	float3 N = mul( float4(IN.mNormal,1), world_IT).xyz;
-    //float3 N = IN.mNormal;
+    float M = 4;
+	
+   	float3 N = IN.mNormal;
     N = normalize( N ); 
-	float3 R = reflect(V, N);
     float3 pos = IN.wPos - lastCenter;
-     
-    float4 intens = 0;
-    //intens = readCubeMap(SmallEnvMapSampler, pos);
- 	
- 	float3 L1, L2, L3, L4, L;
-	float4 Le;
-	float d;
-	  
- 	for (int x = 0; x < REDUCED_CUBEMAP_SIZE - 1; x++)			// az envmap minden texelére
-	 for (int y = 0; y < REDUCED_CUBEMAP_SIZE - 1; y++)
-	 {
-		float2 p, tpos; 
-	    tpos.x = (x + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    tpos.y = (y + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    
-	    p.x = tpos.x; 
-	    p.y = 1-tpos.y;
-	    p.xy = 2 * p.xy - 1;	// -1..1	// az adott texel középpont pozíciója
-	    	    
+    
+   // return float4(N,1)+ lastCenter.x*0.000001; 
+  //  return  readCubeMap(SmallEnvMapSampler, pos) + lastCenter.x*0.000001;
+    
+    float4 I = 0;									
+	float3 L1, L2, L3, L4, L;						
+	float4 Le;										
+	float width = 1.0 / M;							
+	float width2 = width * 2;
+	float d; 
+	
+	for (float x = 0.5; x < M; x++)			
+	 for (float y = 0.5; y < M; y++)											
+	 {																
+		float2 p, tpos; 
+	    tpos.x = x * width;
+	    tpos.y = y * width;
+	    
+	    p = tpos.xy;    
+	    p = 2.0 * p - 1.0; //-1..1
+	    	    	    
 		L1 = float3(p.x - width, p.y - width, 1);	
 		L2 = float3(p.x + width, p.y - width, 1);	
@@ -146,20 +161,20 @@
 		L4 = float3(p.x - width, p.y + width, 1);
 		L = float3(p.x, p.y, 1);
-		Le = readCubeMap(SmallEnvMapSampler, L);
-		d = readDistanceCubeMap(DistanceEnvMapSampler, L);	
-		intens += 0.5 * Le * GetContibution( L1, L2, L3, L4, pos, N, SmallEnvMapSampler, d);
-	}	
-	
-	for (int x = 0; x < REDUCED_CUBEMAP_SIZE - 1; x++)			// az envmap minden texelére
-	 for (int y = 0; y < REDUCED_CUBEMAP_SIZE - 1; y++)
-	 {
-		float2 p, tpos; 
-	    tpos.x = (x + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    tpos.y = (y + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    
-	    p.x = tpos.x; 
-	    p.y = 1-tpos.y;
-	    p.xy = 2 * p.xy - 1;	// -1..1	// az adott texel középpont pozíciója
-	   	
+		Le = float4(readCubeMap(SmallEnvMapSampler, L).rgb, 1);
+		
+		I += 0.5 * Le * GetContibution( L, L1, L2, L3, L4, pos, N, DistanceEnvMapSampler);			
+			
+	}																			
+	
+	for (float x = 0.5; x < M; x++)			
+	 for (float y = 0.5; y < M; y++)											
+	 {																
+		float2 p, tpos; 
+	    tpos.x = x * width;	// 0..1
+	    tpos.y = y * width;	// 0..1
+	    
+	    p = tpos.xy;    
+	    p = 2.0 * p - 1.0; //-1..1
+	    	    	    
 		L4 = float3(p.x - width, p.y - width, -1);	
 		L3 = float3(p.x + width, p.y - width, -1);	
@@ -167,20 +182,19 @@
 		L1 = float3(p.x - width, p.y + width, -1);
 		L = float3(p.x, p.y, -1);
-		Le = readCubeMap(SmallEnvMapSampler, L);
-		d = readDistanceCubeMap(DistanceEnvMapSampler, L);	
-		intens += 0.5 * Le * GetContibution( L1, L2, L3, L4, pos, N, SmallEnvMapSampler, d);
-	}
-	
-	for (int x = 0; x < REDUCED_CUBEMAP_SIZE - 1; x++)			// az envmap minden texelére
-	 for (int y = 0; y < REDUCED_CUBEMAP_SIZE - 1; y++)
-	 {
-		float2 p, tpos; 
-	    tpos.x = (x + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    tpos.y = (y + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    
-	    p.x = tpos.x; 
-	    p.y = 1-tpos.y;
-	    p.xy = 2 * p.xy - 1;	// -1..1	// az adott texel középpont pozíciója
-	   	
+		Le = float4(readCubeMap(SmallEnvMapSampler, L).rgb, 1);
+		
+		I += 0.5 * Le * GetContibution( L, L1, L2, L3, L4, pos, N, DistanceEnvMapSampler);			
+	 }	
+	 
+	for (float x = 0.5; x < M; x++)			
+	 for (float y = 0.5; y < M; y++)											
+	 {																
+		float2 p, tpos; 
+	    tpos.x = x * width;	// 0..1
+	    tpos.y = y * width;	// 0..1
+	    
+	    p = tpos.xy;    
+	    p = 2.0 * p - 1.0; //-1..1
+	    	    	    
 		L4 = float3(p.x - width, 1, p.y - width);
 		L3 = float3(p.x + width, 1, p.y - width);	
@@ -188,20 +202,19 @@
 		L1 = float3(p.x - width, 1, p.y + width);			
 		L = float3(p.x, 1, p.y);
-		Le = readCubeMap(SmallEnvMapSampler, L);
-		d = readDistanceCubeMap(DistanceEnvMapSampler, L);	
-		intens += 0.5 * Le * GetContibution( L1, L2, L3, L4, pos, N, SmallEnvMapSampler, d);
-	}
-	
-	for (int x = 0; x < REDUCED_CUBEMAP_SIZE - 1; x++)			// az envmap minden texelére
-	 for (int y = 0; y < REDUCED_CUBEMAP_SIZE - 1; y++)
-	 {
-		float2 p, tpos; 
-	    tpos.x = (x + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    tpos.y = (y + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    
-	    p.x = tpos.x; 
-	    p.y = 1-tpos.y;
-	    p.xy = 2 * p.xy - 1;	// -1..1	// az adott texel középpont pozíciója
-	   	
+		Le = float4(readCubeMap(SmallEnvMapSampler, L).rgb, 1);
+		
+		I += 0.5 * Le * GetContibution( L, L1, L2, L3, L4, pos, N, DistanceEnvMapSampler);			
+	 }		
+	 
+	for (float x = 0.5; x < M; x++)			
+	 for (float y = 0.5; y < M; y++)											
+	 {																
+		float2 p, tpos; 
+	    tpos.x = x * width;	// 0..1
+	    tpos.y = y * width;	// 0..1
+	    
+	    p = tpos.xy;    
+	    p = 2.0 * p - 1.0; //-1..1
+	    	    	    
 		L1 = float3(p.x - width, -1, p.y - width);
 		L2 = float3(p.x + width, -1, p.y - width);	
@@ -209,20 +222,19 @@
 		L4 = float3(p.x - width, -1, p.y + width);			
 		L = float3(p.x, -1, p.y);
-		Le = readCubeMap(SmallEnvMapSampler, L);
-		d = readDistanceCubeMap(DistanceEnvMapSampler, L);	
-		intens += 0.5 * Le * GetContibution( L1, L2, L3, L4, pos, N, SmallEnvMapSampler, d);
-	}
-	
-	for (int x = 0; x < REDUCED_CUBEMAP_SIZE - 1; x++)			// az envmap minden texelére
-	 for (int y = 0; y < REDUCED_CUBEMAP_SIZE - 1; y++)
-	 {
-		float2 p, tpos; 
-	    tpos.x = (x + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    tpos.y = (y + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    
-	    p.x = tpos.x; 
-	    p.y = 1-tpos.y;
-	    p.xy = 2 * p.xy - 1;	// -1..1	// az adott texel középpont pozíciója
-	   	
+		Le = float4(readCubeMap(SmallEnvMapSampler, L).rgb, 1);
+		
+		I += 0.5 * Le * GetContibution( L, L1, L2, L3, L4, pos, N, DistanceEnvMapSampler);			
+	 }
+	 
+	 for (float x = 0.5; x < M; x++)			
+		for (float y = 0.5; y < M; y++)											
+		{																
+		float2 p, tpos; 
+	    tpos.x = x * width;	// 0..1
+	    tpos.y = y * width;	// 0..1
+	    
+	    p = tpos.xy;    
+	    p = 2.0 * p - 1.0; //-1..1
+	    	    	    
 		L1 = float3(1, p.x - width, p.y - width);
 		L2 = float3(1, p.x + width, p.y - width);	
@@ -230,20 +242,19 @@
 		L4 = float3(1, p.x - width, p.y + width);	
 		L = float3(1, p.x, p.y);
-		Le = readCubeMap(SmallEnvMapSampler, L);
-		d = readDistanceCubeMap(DistanceEnvMapSampler, L);	
-		intens += 0.5 * Le * GetContibution( L1, L2, L3, L4, pos, N, SmallEnvMapSampler, d);
+		Le = float4(readCubeMap(SmallEnvMapSampler, L).rgb, 1);
+		
+		I += 0.5 * Le * GetContibution( L, L1, L2, L3, L4, pos, N, DistanceEnvMapSampler);			
 	}
-	
-	for (int x = 0; x < REDUCED_CUBEMAP_SIZE - 1; x++)			// az envmap minden texelére
-	 for (int y = 0; y < REDUCED_CUBEMAP_SIZE - 1; y++)
-	 {
-		float2 p, tpos; 
-	    tpos.x = (x + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    tpos.y = (y + 0.5) /(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    
-	    p.x = tpos.x; 
-	    p.y = 1-tpos.y;
-	    p.xy = 2 * p.xy - 1;	// -1..1	// az adott texel középpont pozíciója
-	   	
+	 
+	for (float x = 0.5; x < M; x++)			
+	 for (float y = 0.5; y < M; y++)											
+	 {																
+		float2 p, tpos; 
+	    tpos.x = x * width;	// 0..1
+	    tpos.y = y * width;	// 0..1
+	    
+	    p = tpos.xy;    
+	    p = 2.0 * p - 1.0; //-1..1
+	    	    	    
 		L4 = float3(-1, p.x - width, p.y - width);
 		L3 = float3(-1, p.x + width, p.y - width);	
@@ -251,102 +262,68 @@
 		L1 = float3(-1, p.x - width, p.y + width);	
 		L = float3(-1, p.x, p.y);
-		Le = readCubeMap(SmallEnvMapSampler, L);
-		d = readDistanceCubeMap(DistanceEnvMapSampler, L);	
-		intens += 0.5 * Le * GetContibution( L1, L2, L3, L4, pos, N, SmallEnvMapSampler, d);
-	}	
-	
-	
-	//return float4(pos, 1);
-	return intens;
-}
-
-*/
-
-
-float4 DiffusePS( vertOUT IN,
-           uniform float3 cameraPos,
-           uniform float3 lastCenter,	//LI//
-           uniform samplerCUBE SmallEnvMapSampler : register(s0),
-           uniform samplerCUBE DistanceEnvMapSampler : register(s1),
-           uniform float4x4 world_IT
-            ) : COLOR0
-{
-	float3 corner[] = {float3(1,-1,1),//  float3(0,0,1),
-					float3(-1,-1,-1),  // 0,0,-1
-					float3(-1,1,-1),   // 0,1,0
-					float3(-1,-1, 1),  // 0,-1,0
-					float3(1,-1,-1),   // 1,0,0
-					float3(-1,-1, 1)}; // -1,0,0
-					 
-	float3 right[] = {float3(-1,0,0),
-					float3(1,0,0),
-					float3(1,0,0),
-					float3(-1,0,0),
-					float3(0,0,1),
-					float3(0,0,-1)};
-					 
-	float3 up[] = {float3(0,1,0),
-					float3(0,1,0),
-					float3(0,0,1),
-					float3(0,0,1),
-					float3(0,1,0),
-					float3(0,1,0)};
-				 
-    REDUCED_CUBEMAP_SIZE = 4;
-	float width = 1.0 /REDUCED_CUBEMAP_SIZE;
-   
-    //V = /*-*/normalize( V );
-    float3 V = normalize(IN.wPos - cameraPos);	// 
-	float3 N = mul( float4(IN.mNormal,1), world_IT).xyz;
-    //float3 N = IN.mNormal;
+		Le = float4(readCubeMap(SmallEnvMapSampler, L).rgb, 1);
+		
+		I += 0.5 * Le * GetContibution( L, L1, L2, L3, L4, pos, N, DistanceEnvMapSampler);				
+	 }	
+	 float kd = 0.3;																		
+	return kd * I;
+}
+
+float4 P2PContr(float3 N, float3 Nl, float3 pos, float3 L, samplerCUBE cubemap, samplerCUBE distmap)
+{
+	Nl = normalize(Nl);
+	L = normalize(L);
+	float4 Le = readCubeMap(cubemap, L);
+	float d = readDistanceCubeMap(distmap, L);
+	float3 Lpos = L * d;
+	float3 Ldir = Lpos - pos;
+	float dist = dot(Ldir, Ldir);
+	Ldir = normalize(Ldir);
+	dist /= 10000.0;
+	return Le * max(dot(N, Ldir),0) * dot(Nl, -1 * Ldir) / dist;	
+}
+
+float4 EnvMapDiffuseP2PPS( vertOUT IN,
+							uniform float3 lastCenter,	//LI//
+							uniform samplerCUBE SmallEnvMapSampler : register(s0),
+							uniform samplerCUBE DistanceEnvMapSampler : register(s1)) : COLOR			
+{		
+	float M = 4.0;	
+	
+   	//float3 N = mul( world_IT, float4(IN.mNormal,1)).xyz;
+    float3 N = IN.mNormal;
     N = normalize( N ); 
-	float3 R = reflect(V, N);
-    float3 pos = IN.wPos - lastCenter;
-     
-    float4 intens = 0;
-    //intens = readCubeMap(SmallEnvMapSampler, pos);
- 	
- 	float3 L1, L2, L3, L4, L;
-	float4 Le;
-	float d;
-	/*  
- 	for (int x = 0; x < REDUCED_CUBEMAP_SIZE; x++)
-	 for (int y = 0; y < REDUCED_CUBEMAP_SIZE; y++)
-		for (int f = 0; f < 6; f++)
-		{
-		
-			float2 p, tpos; 
-			tpos.x = (x + 0.5) * 2 * width;	// 0..2
-			tpos.y = (y + 0.5) * 2 * width;	// 0..2
-		    
-			p = tpos;			
-		    	    
-			L = corner[0] + p.x * right[0] + p.y * up[0];			
-			L1 = normalize(L - width * right[f] + width * up[f]);
-			L2 = normalize(L + width * right[f] + width * up[f]);	
-			L3 = normalize(L + width * right[f] - width * up[f]);	
-			L4 = normalize(L - width * right[f] - width * up[f]);
-			Le = texCUBE(SmallEnvMapSampler, L);
-			d = texCUBE(DistanceEnvMapSampler, L).r;
-			
-			L1 = d * L1;
-			L2 = d * L2;
-			L3 = d * L3;
-			L4 = d * L4;	
-		
-			float3 r1 = normalize(L1 - pos);    
-			float3 r2 = normalize(L2 - pos);
-			float3 r3 = normalize(L3 - pos);
-			float3 r4 = normalize(L4 - pos); 
-	   
-			float tri1 = acos(dot(r1, r2)) * dot(cross(r1, r2), N);
-			float tri2 = acos(dot(r2, r3)) * dot(cross(r2, r3), N);
-			float tri3 = acos(dot(r3, r4)) * dot(cross(r3, r4), N);
-			float tri4 = acos(dot(r4, r1)) * dot(cross(r4, r1), N);
-		
-		//	intens += Le / 16.0 + pos.x*0.000000000001;
-			intens += 0.5 * Le * max(tri1 + tri2 + tri3 + tri4, 0);
-		}*/	
-
-	return intens;
-}
+    float3 pos = IN.wPos - lastCenter;																		
+													
+    float4 I = 0;									
+	float3 L;						
+	float4 Le;										
+	float width = 1.0 / M;
+	float d;							
+	
+	//float vdir = length(pos);
+	//return (readDistanceCubeMap(DistanceEnvMapSampler, pos) - vdir);
+	//return readCubeMap(SmallEnvMapSampler, pos);
+	//return readDistanceCubeMap(DistanceEnvMapSampler, pos);
+	
+	for (float x = 0.5; x < M; x++)			
+	 for (float y = 0.5; y < M; y++)											
+	 {																
+		float2 p, tpos; 
+	    tpos.x = x * width;
+	    tpos.y = y * width;
+	    
+	    p = tpos.xy;    
+	    p = 2.0 * p - 1.0; //-1..1
+	    	    	    
+		I += P2PContr(N, float3(0,0,-1), pos, float3(p.x, p.y, 1), SmallEnvMapSampler, DistanceEnvMapSampler);
+		I += P2PContr(N, float3(0,0,1), pos, float3(-p.x, p.y, -1), SmallEnvMapSampler, DistanceEnvMapSampler);
+		I += P2PContr(N, float3(-1,0,0), pos, float3(1, p.y, -p.x), SmallEnvMapSampler, DistanceEnvMapSampler);
+		I += P2PContr(N, float3(1,0,0), pos, float3(-1, p.y, p.x), SmallEnvMapSampler, DistanceEnvMapSampler);
+		I += P2PContr(N, float3(0,-1,0), pos, float3(p.x, 1, -p.y), SmallEnvMapSampler, DistanceEnvMapSampler);
+		I += P2PContr(N, float3(0,1,0), pos, float3(p.x, -1, p.y), SmallEnvMapSampler, DistanceEnvMapSampler);
+	}
+																		
+	float kd = 0.8;																		
+	return kd * I;															
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h	(revision 1487)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h	(revision 1590)
@@ -200,4 +200,6 @@
 		mFrameListener= new ParticleDemoFrameListener(mWindow,
 											mCamera	);
+		mFrameListener->setPriority(1);
+		OgreIlluminationManager::getSingleton().setPriority(2);
     mRoot->addFrameListener(mFrameListener);
 	mRoot->addFrameListener(&OgreIlluminationManager::getSingleton());
